/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games;
import javachan.*;
import gabien.IGrInDriver.IImage;
/**
 *
 * @author matt
 */
public class OpeningGame implements IGame {
    public double inwards=0,fadeOut=0;
    public boolean fadingOut=false;
    @Override
    public void doUpdate(double DeltaTime, double Time, Game g) {
        if (!g.music.isPlaying())
        {
        g.music.setMusic("Pmd/Mizuno.pmd");
        g.music.playMusic();
        }
        g.graphics.clearAll(255,255,255);
        IImage ii=g.graphics.getImage("Pbm/Opening.pbm",0,0,0);
        int p=(int)(Time*50.0);
        g.graphics.blitImage(248,0,72,72,132,137,ii);//frog
        if ((Math.floor(Time*2)%2)==0)
        g.graphics.blitImage(248,72,72,9,128,126,ii);//press Z
        g.graphics.blitImage(48,64,200,24,g.graphics.getWidth()-InwardCheck((int)(inwards*(g.graphics.getWidth()-66)),g.graphics.getWidth()-66),205,ii);
        for (int z=-1;z<=(g.graphics.getHeight()/64)+1;z++)
        {
        g.graphics.blitBCKImage(0,0,48,64,InwardCheck((int)(inwards*48),48)-48,(p&63)+(z*64),ii);
        g.graphics.blitBCKImage(0,64,48,64,g.graphics.getWidth()-InwardCheck((int)(inwards*48),48),(p&63)+(z*64),ii);
        }
        //target of this one is 45.starts at -64.note:this is also a good sync check-real one keeps in sync with the rails
        g.graphics.blitImage(48,0,200,64,65,((int)(inwards*(45+64)))-64,ii);
        
        inwards+=DeltaTime/2;
        if (inwards>1) inwards=1;
        if (fadingOut)
        {
            fadeOut+=DeltaTime*32;
        }
        if (g.graphics.isKeyJustPressed(Keymap.VK_SWIM))
        {
            fadingOut=true;
        }
        if (MainGame.fadeDrawer((int)fadeOut, true, g.graphics))
        {
                g.graphics.clearKeys();
                g.gameState=new MainGame();
        }
        g.graphics.flush();
        
    }

    private int InwardCheck(int i, int i0) {
        if (inwards>0.99) return i0;
        return i;
    }
    
}
