/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games;

import gabien.IGrInDriver.IImage;
import javachan.Game;
import javachan.IGame;

public class EditorNpcMenuGame implements IGame {

    public EditorGame base;
    public int Mx,My;
    public EditorNpcMenuGame(EditorGame editorGame,int mx,int my) {
        base=editorGame;
        Mx=mx;
        My=my;
    }

    @Override
    public void doUpdate(double DeltaTime, double Time, Game g) {
        IImage edit = g.graphics.getImage("TileEditor.png", 0, 0, 0);
        g.graphics.clearAll(0, 0, 0);
        g.graphics.blitImage(128, 32, 32, 16, 8, 8, edit);
        if (base.selectedNPC!=-1)
            g.graphics.blitImage(80, 32, 48, 16, 8, 41, edit);
        //"old-style" click zones
        if (g.graphics.getMouseJustDown())
        {
            if (g.graphics.getMouseY()>=8)
                if (g.graphics.getMouseY()<40)
                {
                    base.createNPC(Mx,My);
                }
            if (base.selectedNPC!=-1)
                if (g.graphics.getMouseY()>=41)
                    if (g.graphics.getMouseY()<73)
                    {
                        base.deleteNPC();
                    }
            g.gameState=base;
            g.graphics.clearKeys();
        }
        g.graphics.flush();
    }

}
